function K2BVideoCallTwilio(JQuery) {
  this.$ = JQuery;

  //Controls
  this.container = null;
  this.toggleCamButton = null;
  this.toggleMicButton = null;
  this.toggleScreenButton = null;
  this.mainVideo = null;
  this.localVideo = null;
  this.remoteVideos = null;

  this.room = null;

  var uc = this;

  // Databinding for property GridOrders
  this.SetVideoCallConfiguration = function (data) {
    ///UserCodnding for property GridOrders
    this.VideoCallConfiguration = data;
  };
  this.GetVideoCallConfiguration = function () {
    ///UserCodeRegionStareRegionStart:[SetGridOrders] (do not remove this comment.)
    return this.VideoCallConfiguration;
    ///UserCodeRegionEnd: (do not remove this comment.)
  };

  // Databit:[GetGridOrders] (do not remove this comment.)

  ///UserCodeRegionEnd: (do not remove this comment.)
  this.show = function () {
    if (!this.IsPostBack) {
      this.createDOMStructure();
    }
  };

  this.createDOMStructure = function () {
    this.container = this.$('#' + this.ContainerName);

    this.mainVideo = this.$("<div class='K2BVC_MainVideo' id='k2bvc_main_video' />");
    this.localVideo = this.$("<div class='K2BVC_LocalVideo' id='k2bvc_local_video' />");

    var buttonsContainer = this.$("<div class='K2BVC_ToggleButtonsContainer' />");
    this.toggleCamButton = this.$("<div class='K2BVC_ToggleButton' id='k2bvc_toggle_cam'><i class='fas fa-video K2BVC_ButtonIcon'></i></div>");
    this.toggleMicButton = this.$("<div class='K2BVC_ToggleButton' id='k2bvc_toggle_mic'><i class='fas fa-microphone K2BVC_ButtonIcon'></i></div>");
    this.toggleScreenButton = this.$("<div class='K2BVC_ToggleButton K2BVC_ToggleDisabled' id='k2bvc_toggle_screen'><i class='fas fa-desktop K2BVC_ButtonIcon'></i></div>");
    this.hangupButton = this.$("<div class='K2BVC_ToggleButton K2BT_HangupButton' id='k2bvc_hangup'><i class='fas fa-phone-slash K2BVC_ButtonIcon'></i></div>");
    this.remoteVideos = this.$("<span class='K2BVC_RemoteVideoList' id='k2bvc_remote_videos' />");
    this.noParticipantsDiv = this.$("<div class='K2BVC_NoParticipantsDiv'></div>");
    this.noParticipantsDiv.text(this.NoParticipantsCaption);
    this.localVideoEmptyState = this.$("<div class='K2BVC_LocalParticipantName'></div>");

    this.$(this.container).append(this.mainVideo);
    this.$(this.container).append(this.localVideo);
    this.$(this.localVideo).append(this.localVideoEmptyState);
    this.$(buttonsContainer).append(this.toggleCamButton);
    this.$(buttonsContainer).append(this.toggleMicButton);
    this.$(buttonsContainer).append(this.hangupButton);
    this.$(this.container).append(buttonsContainer);
    this.$(this.container).append(this.remoteVideos);
    this.$(this.remoteVideos).append(this.noParticipantsDiv);
    this.updateParticipantCount();

    this.toggleCamButton.on('click', function (e) {
      disabled = uc.toggleCamButton.hasClass('K2BVC_ToggleDisabled');
      uc.room.localParticipant.videoTracks.forEach(publication => {
        if (disabled) publication.track.enable();
        else publication.track.disable();
      });
      uc.toggleCamButton.toggleClass('K2BVC_ToggleDisabled');
    });

    this.toggleMicButton.on('click', function (e) {
      disabled = uc.toggleMicButton.hasClass('K2BVC_ToggleDisabled');
      uc.room.localParticipant.audioTracks.forEach(publication => {
        if (disabled) publication.track.enable();
        else publication.track.disable();
      });
      uc.toggleMicButton.toggleClass('K2BVC_ToggleDisabled');
    });

    this.hangupButton.on('click', function () {
      uc.disconnectCall();
    });
  };

  this.startCall = function () {
    Twilio.Video.connect(this.VideoCallConfiguration.Token, { name: uc.VideoCallConfiguration.RoomName, video: true, audio: true }).then(
      room => {
        console.log(`Successfully joined a Room: ${room}`);
        uc.room = room;

        room.participants.forEach(participant => {
          participant.tracks.forEach(publication => {
            if (publication.track) {
              participantBox = uc.createParticipantBox(participant.sid, participant.identity);
              $(participantBox).children('.K2BVC_VideoContainer').append(track.attach());
              uc.handleTrackEnabled(participant, track);
            }
          });

          uc.setupParticipantEvents(participant);
        });

        uc.localVideoEmptyState.text(uc.room.localParticipant.identity);
        uc.room.localParticipant.tracks.forEach(publication => {
          const track = publication.track;
          $(uc.localVideo).append(track.attach());

          track.on('enabled', function () {
            if (track.kind === 'video') {
              uc.localVideo.removeClass('K2BVC_LocalVideoDisabled');
            }
          });

          track.on('disabled', function () {
            if (track.kind === 'video') {
              uc.localVideo.addClass('K2BVC_LocalVideoDisabled');
            }
          });
        });

        room.on('participantConnected', participant => {
          console.log(`Participant "${participant.identity}" connected`);

          participant.tracks.forEach(publication => {
            if (publication.isSubscribed) {
              const track = publication.track;

              participantBox = uc.createParticipantBox(participant.sid, participant.identity);
              $(participantBox).children('.K2BVC_VideoContainer').append(track.attach());
              uc.handleTrackEnabled(participant, track);
            }
          });

          uc.setupParticipantEvents(participant);
        });

        room.on('participantDisconnected', participant => {
          console.log(`Participant disconnected: ${participant.identity}`);
          uc.removeParticipantBox(participant.sid);
        });

        room.on('disconnected', room => {
          if (typeof uc.MeetingClosed == 'function') {
            uc.MeetingClosed();
          }

          // Detach the local media elements
          room.localParticipant.tracks.forEach(publication => {
            const attachedElements = publication.track.detach();
            attachedElements.forEach(element => element.remove());
          });
        });
      },
      error => {
        console.error(`Unable to connect to Room: ${error.message}`);
      },
    );
  };

  this.setupParticipantEvents = function (participant) {
    participant.on('trackSubscribed', track => {
      participantBox = uc.createParticipantBox(participant.sid, participant.identity);
      $(participantBox).children('.K2BVC_VideoContainer').append(track.attach());
      uc.handleTrackEnabled(participant, track);
    });
  };

  this.handleTrackEnabled = function (participant, track) {
    var t = track;
    var participantBox = $('#k2bvc_remote_videos .K2BVC_VideoItem[data-k2bvc-participant="' + participant.sid + '"]');
    if (track.kind === 'video' && track.isEnabled) {
      participantBox.removeClass('K2BVC_VideoDisabled');
    } else if (track.kind === 'video') {
      participantBox.addClass('K2BVC_VideoDisabled');
    }

    track.on('enabled', function () {
      if (t.kind === 'video') {
        participantBox.removeClass('K2BVC_VideoDisabled');
      }
    });

    track.on('disabled', function () {
      if (t.kind === 'video') {
        participantBox.addClass('K2BVC_VideoDisabled');
      }
    });
  };

  this.createParticipantBox = function (sid, identity) {
    var participantBox = $('#k2bvc_remote_videos .K2BVC_VideoItem[data-k2bvc-participant="' + sid + '"]');
    if (participantBox.length == 0) {
      participantBox = $("<div class='K2BVC_VideoItem'><div class='K2BVC_VideoContainer'></div><div class='K2BVC_ParticipantName'></div></div>");
      participantBox.attr('data-k2bvc-participant', sid);
      $(participantBox).children('.K2BVC_ParticipantName').text(identity);
      this.remoteVideos.append(participantBox);
      this.updateParticipantCount();
    }
    return participantBox;
  };

  this.removeParticipantBox = function (sid) {
    var participantBox = $('#k2bvc_remote_videos .K2BVC_VideoItem[data-k2bvc-participant="' + sid + '"]');
    if (participantBox.length > 0) {
      $(participantBox).remove();
    }
    this.updateParticipantCount();
  };

  this.updateParticipantCount = function () {
    var participantCount = $(this.remoteVideos).children().length - 1;
    $(this.remoteVideos).attr('data-k2bt-participants', participantCount);
    if (participantCount == 0) {
      $(this.noParticipantsDiv).show();
    } else {
      $(this.noParticipantsDiv).hide();
    }
  };

  this.disconnectCall = function () {
    if (this.room != null) {
      this.room.disconnect();
    }
  };
}
